% For use with Matlab
% Copyright (C) 2019 -- Jerome Mendes <jermendes@gmail.com> or <jermendes@isr.uc.pt>, Rui Araujo <rui@isr.uc.pt>
% Jerome Mendes, Francisco Souza, Rui Araujo, and Saeid Rastegar. "Neo-fuzzy neuron learning using backfitting algorithm". Neural Computing and Application, 2019.
% The "GAM-ZOTS toolbox" comes with ABSOLUTELY NO WARRANTY;
% In case of publication of any application of this method, please, cite the work:
% Jerome Mendes, Francisco Souza, Rui Araujo, and Saeid Rastegar. 
% Neo-fuzzy neuron learning using backfitting algorithm.
% Neural Computing and Applications, 31(8):3609-3618, August 2019.
% DOI: https://doi.org/10.1007/s00521-017-3301-4
% http://www.isr.uc.pt/~jermendes/    ;     http://www.isr.uc.pt/~rui/

function [x] = C_FAM (data_ytrain, data_xtrain, limit_it, limit_theta, dataTotal_x, per_extra, N)
    %% Description
    % This function represents the learning algorithm (Algorithm 2)
    %% Function inputs
    % data_ytrain - Train dataset of output variable
    % data_xtrain - Train dataset of input variables
    % limit_it - maximal number of learning interactions - variable lim_{it}
    % limit_theta - Termination condition - variable \epsilon
    % dataTotal_x - All dataset of input variables
    % per_extra - percentage extra to increase the limits of the universe of
    % discourse of the input variables
    % N - Number of fuzzy rules per input variable
    %% Function output
    % x - Struct with all parameters of the neo-fuzzy


%% Fuzzy Rules Design Initialization - Algorithm 2 Step 2
x = Initialization (dataTotal_x, per_extra, N); % Definition of the struct that contain all parameters information; and Define/design the antecedent part

%% Consequent Design  - Algorithm 2 Step 3
x = AdditiveModels_C(data_ytrain, data_xtrain, x, limit_it, limit_theta); % learning algorithm

end
